prdm <- function(fdp,fda,chutes, dados,method="Nelder-Mead"){
  resultado = parametros = dados_ordenados = n = y = u <- NULL
  W_temp = A_temp = A_2 = W_2 <- NULL
  
  vero = function(par,x){
    -sum(log(fdp(par,x)))
  }
  
  if(method=="Nelder-Mead"){
    resultado = optim(chutes,fn = vero, x=dados, control = list(maxit = 50000),
                      method="Nelder-Mead")
  }
  
  if(method=="BFGS"){
    resultado = optim(chutes,fn = vero, x=dados, control = list(maxit = 50000),
                      method="BFGS")    
  }
  
  if(method=="nlminb"){
    resultado = nlminb(start=chutes,objective = vero, x=dados)
  }
  
  parametros = resultado$par
  dados_ordenados = sort(dados)
  v = fda(as.vector(parametros),dados_ordenados) # Dados ordenados.
  n = length(dados) # Tamanho da amostra.
  y = qnorm(v) # Inversa da acumulada da normal.
  u = pnorm((y-mean(y))/sqrt(var(y)))
  
  W_temp <- vector()
  A_temp <- vector()
  
  for(i in 1:n){
    W_temp[i] = (u[i] - (2*i-1)/(2*n))^2
    A_temp[i] = (2*i-1)*log(u[i]) + (2*n+1-2*i)*log(1-u[i])
  }
  
  A_2 = -n - mean(A_temp)
  W_2 = sum(W_temp) + 1/(12*n)
  W_estrela = W_2*(1+0.5/n)
  A_estrela = A_2*(1+0.75/n + 2.25/n^2)
  
  p = length(parametros)
  log.likelihood = -1*vero(parametros,dados) 
  AICc = -2*log.likelihood + 2*p + 2*(p*(p+1))/(n-p-1)
  AIC = -2*log.likelihood + 2*p
  BIC = -2*log.likelihood + p*log(n)
  resultado = (list("W_estrela" = W_estrela,"A_estrela" = A_estrela,
                    "EMV" = parametros, "AIC" = AIC ,"CAIC " = AICc, "BIC" = BIC))
  return(resultado)

} 
